<?php
// $Id: sina_open.pages.inc,v 1.1 2010/07/25 15:43:36 eastcn Exp $

/**
 * 获取授权令牌并在 Drupal 可登录
 */
function sina_open_page_t_login() {
  global $user;
  
  if (isset($_SESSION['sina_t_oauth_access_token'])) {
    _sina_open_t_login();
  }
  
  if ($_GET['op'] == 'validate') {
    if (!isset($_SESSION['sina_t_oauth_access_token'])) {
      if ($tok = sina_open_t_access_token()) {
        
        _sina_open_t_login();
        
      } else {
        
        drupal_set_message('授权未通过验证', 'error');
        drupal_goto('user/login');
        
      }
      
      exit;
    }
  }
  
  if ($to_url = sina_open_t_login_url()) {
    drupal_goto($to_url);
  } else {
    drupal_set_message('新浪服务器未响应，无法验证', 'error');
    drupal_goto('user/login');
  }
}

/**
 * 让用户登录，若用户不存在，则创建新用户并登录.
 * 若用户已登录，则将新浪微博帐号绑定
 * 必须先获取访问令牌
 */
function _sina_open_t_login() {
  global $user;
  if ($result = sina_open_t_set_request('http://api.t.sina.com.cn/account/verify_credentials.json')) {
    if ($result->code == 200) {
      if ($json = json_decode($result->data)) {
        
        $authname = $json->name.'@t.sina.com.cn';
        
        $result = db_query("SELECT uid FROM {sina_open_user} WHERE sina_name = '%s'", $authname);
        
        if ($ac = db_fetch_array($result)) {
          $ac = user_load($ac);
        }
        
        if (isset($ac->uid)) {
          
          if ($user->uid) {
            
            if ($user->uid != $ac->uid) {
              drupal_set_message('该帐号已与其它用户绑定', 'error');
              drupal_goto('user/'.$user->uid);
            }
            
          } else {
            user_external_login($ac, 'sina_open');
          }
          
          db_query("UPDATE {sina_open_user} SET token = '%s' WHERE uid = %d",
          serialize($_SESSION['sina_t_oauth_access_token']), $ac->uid);
          
        } else if ($user->uid > 0) {
          // 绑定到当前用户
          if (db_result(db_query('SELECT uid FROM {sina_open_user} WHERE uid = %d', $user->uid))) {
            drupal_set_message('您已经绑定了一个新浪微博帐号', 'error');
            drupal_goto('user/'.$user->uid);
          } else {
            db_query("INSERT INTO {sina_open_user} (uid, sina_name, token, config) VALUES ('%s', '%s', '%s', '')",
            $user->uid, $authname, serialize($_SESSION['sina_t_oauth_access_token']));
          }
          
        } else {
          
          $ac = array(
            'name' => $authname,
            'mail' => $authname,
            'pass' => user_password(),
            'status' => variable_get('user_register', 1) == 1,
            'auth_sina_open' => $authname
          );
          
          if (!$account = user_save('', $ac)) {
            drupal_set_message('无法注册帐号', 'error');
            drupal_goto('user/register');
          }
          
          db_query("INSERT INTO {sina_open_user} (uid, sina_name, token, config) VALUES ('%s', '%s', '%s', '')",
          $account->uid, $account->name, serialize($_SESSION['sina_t_oauth_access_token']));
          
          user_external_login($account);
          
        }
        
        if (isset($_REQUEST['redirect']) && $_REQUEST['redirect']) {
          drupal_goto($_REQUEST['redirect']);
        } else if (isset($_REQUEST['destination']) && $_REQUEST['destination']) {
          drupal_goto($_REQUEST['destination']);
        } else {
          drupal_goto('user');
        }
        
      }
    }
  }
  
  drupal_set_message('无法登录，请重试', 'error');
  drupal_goto('user/login');
}

/**
 * 微博相关设置
 * @param (object) $ac
 */
function sina_open_page_config($ac) {
  $output = '';
  
  $data = db_fetch_object(db_query('SELECT uid, token, sina_name FROM {sina_open_user} WHERE uid = %d', $ac->uid));
  
  if ($data->uid) {
    $items[] = '您绑定的帐号：'. current(explode('@', $data->sina_name, 2));
  } else {
    $items[] = '您还没有绑定帐号，' . l('立即绑定', 'sina_open/t_login');
  }
  
  $output = theme('item_list', $items, '新浪微博', 'ul', array('id' => 'sina_open_page_config'));
  
  return $output;
  
  if ($data = sina_open_t_get_info($ac)) {
    
    if ($data->screen_name) {
      $items[] = '您绑定的帐号：'. $data->screen_name;
      $output = theme('item_list', $items);
    }
    
  } else {
    
  }
  
  return $output;
}